searchData={"items":[{"type":"module","title":"SopsConfigProvider","doc":"","ref":"SopsConfigProvider.html"},{"type":"module","title":"SopsConfigProvider.NestedMap","doc":"Utils to process nested map","ref":"SopsConfigProvider.NestedMap.html"},{"type":"function","title":"SopsConfigProvider.NestedMap.to_keyword_list/1","doc":"","ref":"SopsConfigProvider.NestedMap.html#to_keyword_list/1"},{"type":"module","title":"SopsConfigProvider.Sops","doc":"Utils to process sops encrypted file","ref":"SopsConfigProvider.Sops.html"},{"type":"behaviour","title":"SopsConfigProvider.SopsBehavior","doc":"","ref":"SopsConfigProvider.SopsBehavior.html"},{"type":"callback","title":"SopsConfigProvider.SopsBehavior.check_sops_availability!/1","doc":"","ref":"SopsConfigProvider.SopsBehavior.html#c:check_sops_availability!/1"},{"type":"callback","title":"SopsConfigProvider.SopsBehavior.decrypt!/1","doc":"","ref":"SopsConfigProvider.SopsBehavior.html#c:decrypt!/1"},{"type":"module","title":"SopsConfigProvider.State","doc":"Define data structure for state","ref":"SopsConfigProvider.State.html"},{"type":"function","title":"SopsConfigProvider.State.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"SopsConfigProvider.State.html#__t__/0"},{"type":"function","title":"SopsConfigProvider.State.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"SopsConfigProvider.State.html#ensure_type/2"},{"type":"function","title":"Examples - SopsConfigProvider.State.ensure_type/2","doc":"alias SopsConfigProvider.State\n\n    struct = State.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      State.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> State.ensure_type()","ref":"SopsConfigProvider.State.html#ensure_type/2-examples"},{"type":"function","title":"SopsConfigProvider.State.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"SopsConfigProvider.State.html#ensure_type!/1"},{"type":"function","title":"Examples - SopsConfigProvider.State.ensure_type!/1","doc":"alias SopsConfigProvider.State\n\n    struct = State.new!(first_field: value1, second_field: value2, ...)\n\n    State.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> State.ensure_type!()","ref":"SopsConfigProvider.State.html#ensure_type!/1-examples"},{"type":"function","title":"SopsConfigProvider.State.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n#### Options\n\n  * `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"SopsConfigProvider.State.html#new/2"},{"type":"function","title":"Examples - SopsConfigProvider.State.new/2","doc":"alias SopsConfigProvider.State\n\n    State.new(first_field: value1, second_field: value2, ...)","ref":"SopsConfigProvider.State.html#new/2-examples"},{"type":"function","title":"SopsConfigProvider.State.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"SopsConfigProvider.State.html#new!/1"},{"type":"function","title":"Examples - SopsConfigProvider.State.new!/1","doc":"alias SopsConfigProvider.State\n\n    State.new!(first_field: value1, second_field: value2, ...)","ref":"SopsConfigProvider.State.html#new!/1-examples"},{"type":"function","title":"SopsConfigProvider.State.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n#### Options\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"SopsConfigProvider.State.html#required_fields/1"},{"type":"function","title":"SopsConfigProvider.State.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n#### Options\n\n  * `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"SopsConfigProvider.State.html#typed_fields/1"},{"type":"type","title":"SopsConfigProvider.State.available_file_type/0","doc":"","ref":"SopsConfigProvider.State.html#t:available_file_type/0"},{"type":"type","title":"SopsConfigProvider.State.t/0","doc":"","ref":"SopsConfigProvider.State.html#t:t/0"},{"type":"behaviour","title":"SopsConfigProvider.SystemBehavior","doc":"","ref":"SopsConfigProvider.SystemBehavior.html"},{"type":"callback","title":"SopsConfigProvider.SystemBehavior.cmd/2","doc":"","ref":"SopsConfigProvider.SystemBehavior.html#c:cmd/2"},{"type":"callback","title":"SopsConfigProvider.SystemBehavior.cmd/3","doc":"","ref":"SopsConfigProvider.SystemBehavior.html#c:cmd/3"},{"type":"module","title":"SopsConfigProvider.Utils","doc":"Utils to process sops encrypted file","ref":"SopsConfigProvider.Utils.html"},{"type":"function","title":"SopsConfigProvider.Utils.convert_to_keyword_list!/1","doc":"","ref":"SopsConfigProvider.Utils.html#convert_to_keyword_list!/1"},{"type":"function","title":"SopsConfigProvider.Utils.get_file_type/1","doc":"","ref":"SopsConfigProvider.Utils.html#get_file_type/1"},{"type":"function","title":"SopsConfigProvider.Utils.resolve_secret_file_location!/1","doc":"","ref":"SopsConfigProvider.Utils.html#resolve_secret_file_location!/1"},{"type":"exception","title":"SopsConfigProvider.InitStateError","doc":"","ref":"SopsConfigProvider.InitStateError.html"},{"type":"exception","title":"SopsConfigProvider.Sops.SopsDecryptError","doc":"","ref":"SopsConfigProvider.Sops.SopsDecryptError.html"},{"type":"exception","title":"SopsConfigProvider.Sops.SopsNotInstalledError","doc":"","ref":"SopsConfigProvider.Sops.SopsNotInstalledError.html"},{"type":"exception","title":"SopsConfigProvider.Utils.JSONReadError","doc":"","ref":"SopsConfigProvider.Utils.JSONReadError.html"},{"type":"exception","title":"SopsConfigProvider.Utils.SecretFileNotFoundError","doc":"","ref":"SopsConfigProvider.Utils.SecretFileNotFoundError.html"},{"type":"exception","title":"SopsConfigProvider.Utils.YAMLReadError","doc":"","ref":"SopsConfigProvider.Utils.YAMLReadError.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}